# Marble Machinations Change Log
Game store page: https://crispypin.itch.io/marble-machinations

## v0.3.3 - 2025-04-21
### added
- option to display power direction while overlay is enabled
- show level name in end popup

### changed
- hide tick timing numbers by default
- when multiple I/O silos (or multiple directions of one) are activated in the same tick, they will all output the same value instead of pulling input in an arbitrary order

### fixed
- input bytes are consumed even if the marble can't be created because another one was taking its place
- keybindings activated even when typing in a text field, making especially renaming blueprints difficult
- grid rendering broken on right edge of the screen at some zoom levels and window sizes
- crash when saving config if no user dir exists
- bindings did not properly take into account order of pressing, so Shift+A and A+Shift were treated as the same thing
- after removing a binding that was a superset of another, the remaining one did not stop being blocked by the removed ones additional modifiers until another binding was added or edited

## v0.3.2 - 2025-04-14
### added
- "weird machines" chapter with levels for [deadfish](https://esolangs.org/wiki/Deadfish) and [brainfuck](https://esolangs.org/wiki/Brainfuck)
- "missing levels" section giving access to solutions to levels that are no longer available
- click to collapse chapters in level list
- input bindings for eraser (X), selection (B), blueprint list (Ctrl B), no tool (no default binding)
### fixed
- invalid action ids in the config file key bindings caused everything to revert to default.
- when start and stop are bound to the same thing (as by default), only start works
- when two input bindings had the same trigger but one has a strict subset of the others modifiers, both would activate when the one with more modifiers was pressed. For example (Ctrl+S -> Save) would also trigger (S -> Wire Tool). Now, Shift+S will still trigger Wire Tool, unless Shift+S (or eg. Shift+Ctrl+S) is bound to something else.

## v0.3.1 - 2025-04-05
### fixed
- broken area calculation causing crash when completing a level with a machine wider than it is tall

## v0.3.0 - 2025-04-04
### added
- score number: bounding area
- configurable key bindings for many editor actions
- QWERTY+ASDFGH key bindings for the tile tools by default
- OS clipboard copy/paste, with fallback to old behavior when copying
- cut selection
- in-grid text comments (not yet editable in-game)
- changelog file
- (dev) sub-tick visualisation in debug mode
- (dev) tests and benchmarks
### fixed
- equal comparator did not output one of two incoming signals in some cases, depending on wire length and update order
### changed
- made early levels (1-5) easier and more tutorial-like
- comparators can now power other tiles without a wire between, including other comparators
- directly moving marbles (to adjactent tile without anything between) now have priority over new marbles being created, instead of the two events cancelling each other

## v0.2.1 - 2025-03-14
### added
- "Simple comparison" level
### fixed
- phantom marble (empty tile causing other marbles to bounce away) appearing after multiple machines tried to output to the same location at once

## v0.2.0 - 2024-12-24
*everything else*
